'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactThemed = require('react-themed');

var _reactThemed2 = _interopRequireDefault(_reactThemed);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Mapbox = (_dec = (0, _reactThemed2.default)(/^Mapbox/, {
  pure: true
}), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Mapbox, _Component);

  function Mapbox(props, context) {
    (0, _classCallCheck3.default)(this, Mapbox);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Mapbox.__proto__ || (0, _getPrototypeOf2.default)(Mapbox)).call(this, props, context));

    _this.map = null;
    _this.state = { loaded: false };
    return _this;
  }

  (0, _createClass3.default)(Mapbox, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        map: this.map,
        MapboxGL: this.MapboxGL
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.init();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var map = this.map;
      var center = this.props.center;


      if (map && nextProps.center && this.isCenterChange(center, nextProps.center)) {
        if (nextProps.flyToCenter) {
          map.flyTo(nextProps.center);
        } else {
          map.setCenter(nextProps.center);
        }
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextProps.children !== this.props.children || this.state.loaded !== nextState.loaded;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.map.remove();
    }
  }, {
    key: 'setupMapbox',
    value: function setupMapbox() {
      this.MapboxGL.accessToken = this.props.token;
      var _props = this.props,
          center = _props.center,
          style = _props.style,
          zoom = _props.zoom,
          theme = _props.theme,
          dragRotate = _props.dragRotate;


      return new this.MapboxGL.Map((0, _extends3.default)({
        container: this.container,
        style: style,
        zoom: zoom,
        theme: theme,
        dragRotate: dragRotate
      }, center ? { center: center } : {}));
    }
  }, {
    key: 'init',
    value: async function init() {
      var _this2 = this;

      await new _promise2.default(function (resolve) {
        require.ensure([], function (require) {
          resolve(require( /* webpackChunkName: "mapbox" */'mapbox-gl/dist/mapbox-gl'));
        });
      }).then(function (mapbox) {
        _this2.MapboxGL = mapbox;
        _this2.map = _this2.setupMapbox();

        if (!_this2.props.touchRotate) {
          // disable map rotation using touch rotation gesture
          _this2.map.touchZoomRotate.disableRotation();
        }

        _this2.map.on('style.load', function () {
          _this2.setState({
            loaded: true
          });
        });
      });
    }
  }, {
    key: 'isCenterChange',
    value: function isCenterChange(center, nextCenter) {
      var _ref = center || {},
          lat = _ref.lat,
          lng = _ref.lng;

      var next = nextCenter || {};

      return lat !== next.lat || lng !== next.lng;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          size = _props2.size,
          color = _props2.color,
          theme = _props2.theme,
          className = _props2.className,
          children = _props2.children;


      return _react2.default.createElement(
        'div',
        {
          ref: function ref(x) {
            _this3.container = x;
          },
          className: (0, _classnames2.default)(className, theme.Mapbox, color && theme['Mapbox-' + color], size && theme['Mapbox-' + size])
        },
        this.state.loaded && this.map && children
      );
    }
  }]);
  return Mapbox;
}(_react.Component), _class2.propTypes = {
  className: _propTypes2.default.string,
  size: _propTypes2.default.string,
  color: _propTypes2.default.string,
  theme: _propTypes2.default.object,
  token: _propTypes2.default.string,
  center: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]),
  flyToCenter: _propTypes2.default.bool,
  style: _propTypes2.default.string,
  zoom: _propTypes2.default.number,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.array]),
  dragRotate: _propTypes2.default.bool,
  touchRotate: _propTypes2.default.bool
}, _class2.childContextTypes = {
  map: _propTypes2.default.object,
  MapboxGL: _propTypes2.default.object
}, _class2.defaultProps = {
  theme: {},
  children: [],
  flyToCenter: false,
  dragRotate: true,
  touchRotate: true
}, _temp)) || _class);
exports.default = Mapbox;